#!/usr/bin/perl -I/usr/local/lib/simusol
# simusol3.pl 
#traduce de un archivo $archivo a ..  para gnuplot
use warnings;
use strict;
use Ayudas;
use Text::Abbrev;
use Data::Dumper;
use GlobalesSimusol;
use Tablasfuncq;
use Auxiliares;
#use Algebraico;
# -----------------------------------------------------------------------------
use Getopt::Long;
use Pod::Usage;
system "killall gnuplot_x11 2>/dev/null";

$0 =~ m!/([^/]+)\s*$!;
$progname = $1;my $curdirori = `pwd`; chomp $curdirori; $curdirori .= '/';
$progr{$progname} = '3';
our $PROPIOSIN;
#print STDERR "Estoy en $progname @ARGV\n";
our %reserv_dir;
my $ref3 = {'curdirori' => $curdirori};
foreach my $palabra  ('corto','cortosin','basearchcorto','dirarray') {
    $ref3->{$palabra} = [];
}; 
crear_tmp_simusol();
my ($coderr,$mensaje) = interpretar_opciones_3($ref3);
impr_debug(__LINE__.' sims',Dumper $ref3);
impr_debug(__LINE__.' sim1 opciones',\%opt_hash);  
#----------------------------------------------------------------------------
parars(200,' Pidio no graficar') if $opt_hash{graf} eq '0';
#----------------------------------------------------------------------------
my $largo = 60 - length($progname); 
my $opc_arg = paraimpr3puntos($largo,@ARGV);

# -----------------------------------------------------------------------------
help() if defined $opt_hash{help};
version() if defined $opt_hash{version};
parar3(200,'No pidió nada') if $opt_hash{graf} == 0;
$debug = $opt_hash{d};$noverb = $opt_hash{noverb};
# -----------------------------------------------------------------------------
my $archivosinext;
if(@ARGV == 1 and -e "$ARGV[0].paraplot") {
    $archivosinext = $ARGV[0];
} else {
   ($archivosinext) = elegir_archivos('paraplot');
   $archivosinext =~ s/\.paraplot//;
};
my $pwd = `pwd`; chomp $pwd; $pwd .= '/'; 
our ($BASEARCH, $PROPIO, $CORTO, $PROPIOSINDIA, $CORTOSINDIA) 
    = relativizar($archivosinext,$pwd); 
# $BASEARCH con separador de directorios incluido
chdir $BASEARCH;
#al haber canbiado de directorio solo interesaran,,
# desde aqui, $PROPIO Y $PROPIOSINDIA; para los errores ...
-e 'gnus' or crear_gnus('./');
-d 'gnus' and -w 'gnus' or die "Necesito trabajar con directorio gnus\n"; 
$GlobalesSimusol::CORTOA = $CORTO;
$GlobalesSimusol::PRINCIPAL = $CORTO;
$GlobalesSimusol::CORTOASINDIA = $CORTOSINDIA;
$GlobalesSimusol::PROPIOA = $PROPIO;  
$GlobalesSimusol::PROPIOASINDIA = $PROPIOSINDIA;
$GlobalesSimusol::BASEARCHA = $BASEARCH;
$GlobalesSimusol::pwdori = $pwd;
abrir_LSS1($PROPIOSINDIA,$progname,1);
system "rm $PROPIOSINDIA.gra 2>/dev/null";
my $date = scalar localtime((stat "$PROPIOSINDIA.paraplot")[9]);
mensaje('=-' x 2 ."Mensajes de simusol3.pl,          $PROPIOSINDIA.paraplot, "
          . $date);
# -----------------------------------------------------------------------------
our $refnombreshashes; 
# key nombre de variable propia; valor orden de la var. (empieza con 1)
our $refsceptrehashes; #similar para nombres sceptre
our $archivopadre; #key nombre simbolico de archivo; para variaciones y selec
#  valor nombre simbolico de archivo con igual estructura de variables etc.
# si no hay otro no estara definido 
   
our %term = ('eps' => 'postscript eps', 'png' => 'png');
# los primeros siguientes, con  nombre simbolico de archivo como key 
our (%nombrearch, %nombarch, %exiarch, %reffactor
     , %refvarori
     , %SIMBOARCHORI, %uniabsc, %uniord, %varabsc, %magord
,%marca, %unipri
     , %refparap, %refarch);
# los ultimos anteriores, con nombre de grafo como key:  
# %refind permite pasar de indice de var. propia a indice de sceptre 
$debug = $opt_hash{d};$noverb = $opt_hash{noverb};
our (%plf, %mj, %rx, %ry, %selec, %fun, %titfun, %pun_lin, %todo 
     ,%exigraf, %simbografori
    ,%titx,%tity, %guardar_graf
    ,%noarchresori, %titulograf, %usaarchivos,
    ,%usagraf_coma_arch_cols  
    ,%uniabscisa, %uniordenadas, %prig, %segg
    ,%juntos) = ();
our (%mensajegra, %nomostrar) = ();
our (@mostrarjunto) = (); 
#pedidos concretos de elementos de grafos
# habrá que incorporar otras unidades
# se necesitan los apóstrofes para el gnuplot
my $mensaje_comienzo = ' Preparado por simusol3.pl
    #   Se ejecuta con: gnuplot -persist';  
# -----------------------------------------------------------------------------

our  @separadores = (' +','=','\s*[,:]\s*');
our $archi;# para que pueda nombrarse como ejemplo
our $panta0 = # "set term X11\n". # no hace falta
      #"set locale 'es_ES'\n".
      "set grid\n";
leer_paraplot3("$PROPIOASINDIA.paraplot");
impr_debug(__LINE__.' sim3 %exigraf',\%exigraf);
impr_debug(__LINE__.' sim3 %marca',Dumper \%marca);
if ($opt_hash{graf} eq 1
       or ($opt_hash{graf} and  scalar (keys %exigraf) == 0)) {
    $opt_hash{graf} = 1;
    graficar_interact();
    # gráficos interactivos (a pedido o por falta de pedidos concretos)
} else {
    #contr_jun() if scalar keys %juntos;
    contr();
    # Si no hubo nada para graficar, contr hizo parar3  
    graficar_pedidos();   
};
parar3(0,'');
#termina el principal
# -----------------------------------------------------------------------------
sub interpretar_opciones_3{
  my $ref3 = $_[0];   
  GetOptions(\%opt_hash, 'help','d','version','noclas','graf=s','noverb')
      or pod2usage(2);
  defined $opt_hash{graf} and $opt_hash{graf} =~ /^chic/i 
    and $opt_hash{graf} = 5;
  if (not $opt_hash{graf}) {
      $opt_hash{graf} = 3;
  } elsif ($opt_hash{graf} =~ /\D/) {
      die "Opción para -graf $opt_hash{graf} irreconocible\n";
  }; 
  # --------------------------------------------------------------------------
  parar3(200,' Pidio no graficar') if $opt_hash{graf} eq '0';
  # --------------------------------------------------------------------------
  print STDERR ".....  com3 interpretar_opciones_3($ref3) \n" if $opt_hash{d};
  $debug = $opt_hash{d}; #$debug está definida con our en Ayudas.pm
  if ($opt_hash{noclas}) {
      foreach my $key (keys %dirsalida) {
          substr($dirsalida{$key},0,1) ne 'c' and $dirsalida{$key} = '';
      };
   };
  resolver_outdir($ref3);
  comfin('fin3 interpretar_opciones_3');
  return '';	 
}#interpretar_opciones_3  
# -----------------------------------------------------------------------------
sub leer_info_archivos{#toma informacion util del archivo; control minimo
  comfin('com leer_info_archivos', @_);
  my @primeros = grep (do {$nombrearch{$_} and not $selec{$_}},@_);
  my @posibles = (@primeros,@_); @posibles = union_conorden(@posibles);
  scalar keys %selec and contr_selec();# puede modificar %selec,%nombrearch 
  my $ignor = "se ignorará todo lo que se refiera a ";
  impr_debug(__LINE__.' sim3 @posibles',\@posibles);
#  $archivopadre->{SIMULADO} = 'SIMULADO';
  foreach my $ARCHIVO (@posibles) {   
      $refarch{$ARCHIVO} = {};
      my $refarchARCH =  $refarch{$ARCHIVO}; my $ARCHIVOP ;
      $ARCHIVOP = $archivopadre->{$ARCHIVO};
      if (not defined $ARCHIVOP) {
          $ARCHIVOP = buscar_padre($ARCHIVO);
      };	  
      if (not defined $exiarch{$ARCHIVOP}) {
	  calcular_exiarch($ARCHIVOP);
      };
      $exiarch{$ARCHIVO} = $exiarch{$ARCHIVOP};	  
      my $nombrereal =   $nombrearch{$ARCHIVO}->[0];
      if (defined $nombrereal) {
	  $nombarch{$ARCHIVO} = $nombrereal;
      };	  
       my (@inform, @listaval,@liscuantos);
      my ($ya,$repetidos,$seacabo) = ('','','');
      while (<ARCH>) {
          chomp;
          if (not $ya and s/\#\s*para\s+Simusol\W+//i) {
              $ya = 1;
              @inform = split /\s*,\s*/;
              my @inform_un = union_conjunto (@inform);
              if (@inform == @inform_un) {
                  #los renglones siguientes deben tener la informacion
                  foreach my $que (@inform) {
                      my $renglon = <ARCH>;
                      defined $renglon or do {
                          $seacabo = 1;
                          last; 
                      };
                      chomp $renglon;
                      $renglon =~ s/^\s*\#\s*//;
                      @{$refarchARCH->{$que}} = split /\s+/, $renglon;
                      push @liscuantos,scalar @{$refarchARCH->{$que}}
                        if $que ne 'variables';# por si tienen espacios  
                  };#my $que
                  $seacabo and do{
                      $refarchARCH = {};    
                  last;
                  } 
              } else {
                  $repetidos = 1; 
	      };# if else @inform ==
              next;
          };#if not $ya          
	  next if /\#/ or /^\s*$/; 
          s/^\s*(\S)/$1/;
          @listaval = split /\s+/; 
          $refarchARCH->{valores} = \@listaval; 
          push @liscuantos, scalar @listaval;
          last;
      };#while
      if(not @listaval) {
          avgrav("no hay valores para $ARCHIVO de nombre real $nombrereal");
          $exiarch{$ARCHIVO} = 2; #sin valores numéricos
          next;
      };
      $refarchARCH->{colposibles} = @listaval;
      $ya or  $exiarch{$ARCHIVO} = 7; #arch. sin informacion
      $repetidos and 
           avnoseent("@inform; hay elementos repetidos para información
                 de $nombrereal");
      my @liscuan = union_conjunto(@liscuantos);    
      if (@liscuan == 1) {
          $exiarch{$ARCHIVO} = 10; # puede disminuir luego de otros controles 
      } else {
	  avnoseent("la información propia de $nombrereal;
            @liscuantos; debieran resultar iguales");
          $exiarch{$ARCHIVO} = 6; #inconsistencia en informacion
      };
      my $exiARCH = $exiarch{$ARCHIVO};
      my @genericasvar = (1..$refarchARCH->{colposibles});
      my @genericasunimag = @genericasvar;
      map ($_= '',@genericasunimag);
      map ($_ = 'col_'.$_, @genericasvar); 
      ($exiARCH == 7 or not defined $refarchARCH->{sceptrevars}) and 
          @{$refarchARCH->{sceptrevars}} = @genericasvar; 
      ($exiARCH == 7 or not defined $refarchARCH->{variables}) and 
          @{$refarchARCH->{variables}} = @genericasvar; 
      ($exiARCH == 7 or not defined $refarchARCH->{magnitudes}) and 
          @{$refarchARCH->{magnitudes}} = @genericasunimag; 
      ($exiARCH == 7 or not defined $refarchARCH->{unidades}) and 
          @{$refarchARCH->{unidades}} = @genericasunimag; 
   #if (not defined $nombrereal
  };#for my $ARCHIVO
  $avisosgrav and parar3(210,"Hubo errores en descripcion de archivos");
  impr_debug(__LINE__.' sim3 %exiarch',\%exiarch); 
  @posibles = grep ($exiarch{$_} > 2, keys %exiarch);
  comfin('fin leer_info_archivos');
  return  \@posibles;
}#leer_info_archivos
# -----------------------------------------------------------------------------
sub buscar_padre{
  comfin('com buscar_padre',@_);
  my $ARCHIVO = $_[0]; my $archp;
  my $nombrereal =   $nombrearch{$ARCHIVO}->[0];
  if (not $selec{$ARCHIVO}) {
      if (defined $archivopadre->{$ARCHIVO}) {
	  $archp = $archivopadre->{$ARCHIVO};
      } else {
          $archp = $ARCHIVO; $archivopadre->{$ARCHIVO} = $archp;
      };
  } else {
      impr_debug(__LINE__.' sim3 $selec{$ARCHIVO}'
		 ,Dumper $selec{$ARCHIVO});
      my @lista = @{$selec{$ARCHIVO}->[0]};
      $archp = $lista[0];
      $archivopadre->{$ARCHIVO} = $archp;
  };
  comfin('fin buscar_padre',$archp);
  return $archp;
}#buscar_padre
#----------------------------------------------------------------------------
sub calcular_exiarch{
  comfin('com calcular_exiarch',@_);
  my $ARCHIVO = $_[0];
  my $ignor = "se ignorará todo lo que se refiera a ";
  if (not defined $exiarch{$ARCHIVO} and not $selec{$ARCHIVO}) {
      if (not defined $nombrearch{$ARCHIVO}) {
          $exiarch{$ARCHIVO} = 0; #falta nombre
          avgrav("No se indico nombre real para archivo $ARCHIVO; 
          $ignor $ARCHIVO");
      } else {
          @{$nombrearch{$ARCHIVO}}
            = union_conjunto( @{$nombrearch{$ARCHIVO}}); 
          if (@{$nombrearch{$ARCHIVO}} >1) {
              $exiarch{$ARCHIVO} = 0; #más de un nombre
              avgrav("$ARCHIVO asociado con\n       ".
              join (' y ',  @{$nombrearch{$ARCHIVO}}) . "
          $ignor $ARCHIVO");
          };  
	  my $nombrereal = $nombrearch{$ARCHIVO}->[0];
          if (not -e $nombrereal) {
              $exiarch{$ARCHIVO} = 1;# no existe
              avgrav(__LINE__." No existe el archivo $nombrereal;
          $ignor $ARCHIVO");
          } else {
              open ARCH, $nombrereal or do{
                  $exiarch{$ARCHIVO} = 1; #no abre
                  avgrav("No se pudo abrir $nombrereal;
           $ignor $ARCHIVO");
	      };# open
 	      $exiarch{$ARCHIVO} = 10;#puede disminuir en revision posterior
	      $nombarch{$ARCHIVO} = $nombrereal;
          };
      };
  };      
  comfin('fin calcular_exiarch');
  return    
}#calcular_exiarch   
# -----------------------------------------------------------------------------
sub completar_nombres{
  comfin('com completar_nombres',@_);
  my @posibles = @{$_[0]};
  foreach my $ARCHIVO (@posibles) {
      my $nombrereal = $nombarch{$ARCHIVO};  
      my $refparapARCH = $refparap{$ARCHIVO};
      my $cuantos = $refparapARCH->{colposibles};
      defined $refparapARCH->{ind} and $cuantos = @{$refparapARCH->{ind}};
      my $cuantossc = @{$refparap{$ARCHIVO}->{dni}};
      my @completado= 0;
      foreach my $que ('variables','magnitudes','unidades') {
          if (@{$refparapARCH->{$que}} == $cuantos) {
	  } else {
              if (@{$refparapARCH->{$que}} == 0) {
                  explic("No hay datos sobre $que")  if $opt_hash{graf} != 1;
                  $exiarch{$ARCHIVO} != 7 
                     and $exiarch{$ARCHIVO} = 4; #incompleta
              } else {
                  explic("$ARCHIVO con ".scalar @{$refparapARCH->{$que}}
                   . " $que, distinto de $cuantos") if $opt_hash{graf} != 1; 
                  $exiarch{$ARCHIVO} = 7; #inconsistentes las cantidades
              };
              if ($que eq 'variables') {
                  map (do{push @{$refparapARCH->{variables}},'col_'.($_)}
                      ,@{$refparapARCH->{ind}});
              } else {
                  map (do{push @{$refparapARCH->{$que}}, ''}
                      ,@{$refparapARCH->{ind}});
              };
          }
      };
      if ($opt_hash{graf} != 1) {
          if ($exiarch{$ARCHIVO} == 7) {
              avnograv
        ("Inconsistencia en cantidad de  variables, unidades y/o magnitudes
        para el archivo de nombre simbólico  $SIMBOARCHORI{$ARCHIVO}")
          } elsif ($exiarch{$ARCHIVO} == 3) {
              avnograv("No está completa la descripción del archivo
          de nombre simbólico $SIMBOARCHORI{$ARCHIVO} y real $nombrereal
          Los gráficos pueden resultar incorrectos") 
          }
      }; 
      @{$refparapARCH->{sceptrevars}} == $cuantossc or do{
          #solo se da si ind y dni son triviales   
          map (do{push @{$refparapARCH->{sceptrevars}},'col_'.($_)}
               ,@{$refparapARCH->{ind}});
      };
      @{$refvarori{$ARCHIVO}} = @{$refparap{$ARCHIVO}->{variables}};
      my $j = 1;
      foreach my $nombre (@{$refparap{$ARCHIVO}->{variables}}) {
          $nombre = sanear($nombre); #saca espacios y pone mayusc
	  $refnombreshashes->{$ARCHIVO}->{$nombre} = $j;
	  $refnombreshashes->{$ARCHIVO}->{$j} = $j;
          $j++; # si hay repetidos queda el ultimo
      };
  };
  comfin('fin completar_nombres');
}#contr_nombres
# ---------------------------------------------------------------------------
sub contr_archivos_paraplot{ #lo minimo para asegurar utilidad
  comfin('com contr_archivos_paraplot',@_);
  my @listaARCH = @{$_[0]}; 
  #todos tienen $exiarch 7 o 10; aqui pueden disminuir
  my $ign_info = 'se ignorará esta información';
  foreach my $ARCHIVO (@listaARCH) {
      my $refparapARCH;
      $refparapARCH = $refparap{$ARCHIVO};
       my $nombrereal = $nombrearch{$ARCHIVO}->[0];
      if (not defined $refparapARCH) {
          $refparapARCH = $refparap{$ARCHIVO} = $refarch{$ARCHIVO};
          $refparapARCH->{ind} = [1..$refarch{$ARCHIVO}->{colposibles}];
          @{$refparapARCH->{dni}} = @{$refparapARCH->{ind}};
      } else {
          my $colpos;  
          foreach my $que ('sceptrevars','variables','unidades','magnitudes') {
              defined $refparapARCH->{$que} or $refparapARCH->{$que} = [];
              $colpos or $colpos = @{$refparapARCH->{$que}};
          };     
          if ($colpos) {
              if ($colpos > $refarch{$ARCHIVO}->{colposibles}) {
                  avgrav("Número de columnas de $nombrereal pretendidas en el 
                  archivo $archivosinext.paraplot mayor que el posible;
                  se ignorarán los pedidos referidos a este archivo");
                  $exiarch{$ARCHIVO} = 6;# descrip impos.  en paraplot    
                  $refparapARCH =  $refarch{$ARCHIVO};
                  next; 
              } else {
                  $refparapARCH->{colposibles} = $colpos;
              }
          } else {
              $refparapARCH->{colposibles} = $refarch{$ARCHIVO}->{colposibles};
              $refparapARCH->{ind} = [1..$refparapARCH->{colposibles}];
              $refparapARCH->{dni} = [1..$refparapARCH->{colposibles}];
          }; 
          if (@{$refparapARCH->{variables}} == 0) {$refparapARCH->{ind} = []}; 
          if (@{$refparapARCH->{variables}}) {
              if ($refparapARCH->{ind}) {
                  @{$refparapARCH->{ind}} 
                    == @{$refparapARCH->{variables}} or do{
                      avgrav(
                       "imposible la información de índices y variables para 
                       $nombrereal, ($ARCHIVO)");
                      $exiarch{$ARCHIVO} = 3;#imposible indices y variables
                      next;
                  }; 
                  for(my $j = 0; $j < @{$refparapARCH->{ind}}; $j ++ ) {
                      my $k = $refparapARCH->{ind}->[$j];
                      next if $k == 0; 
                      $refparap{$ARCHIVO}->{dni}->[$k-1] = $j +1; 
                  }; 
                  @{$refparapARCH->{dni}} 
                   <= @{$refparapARCH->{sceptrevars}} or do{
                      avgrav(
                      "imposible la información de índices y sceptrevars para 
                       $nombrereal, ($ARCHIVO)");
                      $exiarch{$ARCHIVO} = 4;#indices y sceptrevars imposibles
                      next;
                  };
 	      } else {
      	          if (@{$refparapARCH->{sceptrevars}}>0 
                      and @{$refparapARCH->{sceptrevars}} 
	        	 < @{$refparapARCH->{variables}}) {
                      avgrav(
                      "imposible la información sobre sceptrevars, variables
                     e índices (no hay índices) para $nombrereal ($ARCHIVO)");
                      $exiarch{$ARCHIVO} = 5;# sceptrevar e ind. imposible
		      next;
                  };
              }; # if $refparapARCH->{ind} else ..
          };# if @{$refparapARCH->{variables}}  else ... == 0 
      }; # if not defined $refparapARCH else defined $refparapARCH
      unless ($refparapARCH->{ind} and @{$refparapARCH->{ind}}) {
          for(my $j = 0; $j < $refparapARCH->{colposibles}; $j ++ ) {
             $refparapARCH->{ind}->[$j] = $j+1;
             $refparapARCH->{dni}->[$j] = $j+1;
          }; 
      };
  }; # for my $ARCHIVO     
  $avisosgrav and parar3(230, '');
  my @posibles = grep ($exiarch{$_} > 5, keys %exiarch);
  comfin('fin contr_archivos_paraplot');
  return \@posibles;
}#contr_archivos_paraplot
#----------------------------------------------------------------------------
sub contr_selec{
  comfin('com contr_selec',@_);
  my $ignor = "se ignorará todo lo que se refiera a ";
  foreach my $ARCHIVO (keys %selec) {
      impr_debug(__LINE__.' sim3 $ARCHIVO',$ARCHIVO);      
      impr_debug(__LINE__.' sim3 $SIMBOARCHORI{$ARCHIVO}'
        ,$SIMBOARCHORI{$ARCHIVO}); 
      impr_debug(__LINE__.' sim3 $nombrearch{$ARCHIVO}'
		 ,$nombrearch{$ARCHIVO});
      impr_debug(__LINE__.' sim3 $nombarch{$ARCHIVO}'
		 ,$nombarch{$ARCHIVO});
      impr_debug(__LINE__.' sim3',Dumper $selec{$ARCHIVO});
      my @listarefselecciones = union_conorden(@{$selec{$ARCHIVO}});
      if (@listarefselecciones >1) {
          avgrav("Mas de una definicion para nombre real de $ARCHIVO;
                    $ignor $ARCHIVO");
          delete $selec{$ARCHIVO}; next;
      };
      my @listaseleccion = @{$listarefselecciones[0]};
      my $archp = $archivopadre->{$ARCHIVO} = uc($listaseleccion[0]);
      $exiarch{$ARCHIVO} = $exiarch{$archp};
      impr_debug(__LINE__.' sim3 $ARCHIVO,@listaseleccion,$archp'
        ,[$ARCHIVO,@listaseleccion,$archp]);
  };    
  comfin('fin contr_selec');
  return      
}#contr_selec      
# -----------------------------------------------------------------------------
sub contr_sobre_archivos{
  comfin('com contr_sobre_archivos',@_);
#  impr_debug(__LINE__.' sim3 %nombarch', Dumper \%nombarch);
  my @archposibles = @{$_[0]};
  my @SIMULADOs = grep(/^SIMULADO/,@archposibles);
  if (@SIMULADOs) {
      @SIMULADOs = union_conorden(sort @SIMULADOs);
      $SIMULADOs[0] eq 'SIMULADO' or do{
          #no hubo archivo ni arch_var para SIMULADO, pero se usan SIMULADO_...
          unshift @SIMULADOs,'SIMULADO';
          push @{$nombrearch{SIMULADO}}, "$archivosinext.simul";
          $SIMBOARCHORI{SIMULADO} = 'SIMULADO';
      };      
  };
  @archposibles = grep ($exiarch{$_} >5, keys %exiarch);
  impr_debug(__LINE__.' sim3 @archposibles',\@archposibles);
  impr_debug(__LINE__.' sim3 %refparap',Dumper \%refparap);  
  foreach my $ARCHIVO (@archposibles) {
      next if $selec{$ARCHIVO};
      my $nombrereal =   $nombarch{$ARCHIVO};
      my $refparapARCH = $refparap{$ARCHIVO};
      if (not defined $refparapARCH->{variaciones}) {
	  $refparapARCH->{variaciones} = [''];
          $marca{$nombrereal} = '';
      } elsif (@{$refparapARCH->{variaciones}} >1) { 
          parar3(30,"En $archivosinext.paraplot Hay más de una definición de 
                variaciones $ARCHIVO");  
      } elsif (@{$refparapARCH->{variaciones}} == 0) {
      } else { #queda     == 1
          $refparapARCH->{variaciones} = $refparapARCH->{variaciones}->[0];
	  $marca{$nombrereal} = $refparapARCH->{variaciones}->[0];
      };
      if (not defined $refparapARCH->{arch_var}) {
	  $refparapARCH->{arch_var} = [$nombrereal];
      } elsif (@{$refparapARCH->{arch_var}} >1) { 
          parar3(32,"En $archivosinext.paraplot Hay más de una definición de 
                arch_var $ARCHIVO");  
      } elsif (@{$refparapARCH->{arch_var}} == 0) {
	  $refparapARCH->{arch_var} = [];
      } else {# queda   == 1
	  $refparapARCH->{arch_var} = $refparapARCH->{arch_var}->[0];
      };
      if (@{$refparapARCH->{arch_var}} 
          and @{$refparapARCH->{variaciones}} == 0) {
          parar3(33,"En $archivosinext.paraplot hay un renglón
             arch_var $ARCHIVO pero no hay un renglón
             variaciones $ARCHIVO");
      };
      if (@{$refparapARCH->{arch_var}} and @{$refparapARCH->{variaciones}} and
	  @{$refparapARCH->{arch_var}} != @{$refparapARCH->{variaciones}}) {
          avnoseent("En $archivosinext.paraplot 
                variaciones $ARCHIVO   y arch_var $ARCHIVO
            tienen distinta cantidad de elementos");
          $refparapARCH->{arch_var} = []; 
          $refparapARCH->{variaciones} = [];   
      };
  }; #$ARCHIVO
  impr_debug(__LINE__.' sim3 %nombarch', Dumper \%nombarch);
  contr_arch_variables(@archposibles);
  contr_variac(@archposibles);
  contr_selec();
  impr_debug(__LINE__.' sim3 %exiarch',\%exiarch);
  foreach my $ARCHIVO (keys %selec) {
      impr_debug(__LINE__.' sim3 $exiarch{$ARCHIVO}',$exiarch{$ARCHIVO});
      next if defined $exiarch{$ARCHIVO} and $exiarch{$ARCHIVO} < 6;
      seleccionar_filas($ARCHIVO,@{$selec{$ARCHIVO}->[0]});
  };
  comfin('fin contr_sobre_archivos');
}#contr_sobre_archivos
# -----------------------------------------------------------------------------
sub contr_variac{
  comfin('com contr_variac', @_);
  my @ARCHIVOS = @_;
  # aqui no uso $archivo_padre; copio los datos
  foreach my $key (@ARCHIVOS) {
      next if $selec{$key};
      my $refparapkey = $refparap{$key};
      my $nombre = $nombarch{$key};
      my @marcas = @{$refparapkey->{variaciones}};
      if (@{$refparapkey->{arch_var}}== 0) {  
          my ($propio,$ext) = ($nombre =~ /^(\w+)(\.\w+)$/);
          if (defined $propio and defined $ext) {
              @{$refparapkey->{arch_var}} = ("$propio$ext");
              for (my $i = 1; $i < @marcas; $i++) {
                  my $nombrei = $propio . "_$i". $ext;
                 (-f $nombrei and -s $nombrei) or
                  parar3(36,"En $archivosinext.paraplot hay un renglón
                  variaciones $key pero no hay un renglón
                  arch_var $key; y no pude crearlo");
                  push  @{$refparapkey->{arch_var}}, $nombrei;
             };
          }; 
      };
      my @listaarch = @{$refparapkey->{arch_var}};
      my $nombremaster = $nombrearch{$key}->[0];
      my ($propio,$ext) = $nombremaster =~ /^(.+)(\.\w+)$/;
      my $noarchvar; 
      $marca{$nombremaster} = $marcas[0];
      for( my $i= 1; $i < @listaarch; $i ++) {
	  my $ARCHi = "${key}_$i";
          my $nombrei = $listaarch[$i]; 
          if (not -f $nombrei or not -s $nombrei) {
             $noarchvar = 1;
          } else {
             $nombarch{$ARCHi} =  $nombrei;
             $exiarch{$ARCHi} = $exiarch{$key};
             my @lista = @{$refvarori{$key}};
             $refvarori{$ARCHi} = [@lista]; 
             @{$refparap{$ARCHi}->{variables}} 
                 = @{$refparap{$key}->{variables}};
             @{$refparap{$ARCHi}->{magnitudes}} 
                 = @{$refparap{$key}->{magnitudes}};
             $refparap{$ARCHi}->{unidades} = $refparap{$key}->{unidades};
	     $refparap{$ARCHi}->{sceptrevars} = $refparap{$key}->{sceptrevars};
             $marca{$nombrei} = $marcas[$i];  
             $unipri{$ARCHi} = $unipri{$key};
             $refparap{$ARCHi}->{arch_var} = [];
             $refnombreshashes->{$ARCHi} = $refnombreshashes->{$key};
	 };
	 if ($noarchvar) {
             avnograv("No se pueden atender arch_var; 
              no existen todos los archivos"); 
             $refparapkey->{arch_var} = [];$refparapkey->{variaciones} = [];
         };
      }; 
  };
  comfin('fin contr_variac');
} #contr_variac
# -----------------------------------------------------------------------------
sub contr_arch_variables{
  comfin('com contr_arch_variables');
   my @listaARCH = @_;
  foreach my $ARCHIVO (@listaARCH) {
      if ($refparap{$ARCHIVO}->{sceptrevars} 
           and $refparap{$ARCHIVO}->{variables}) {
          for (my $j = 0; $j < @{$refparap{$ARCHIVO}->{sceptrevars}}; $j++) {
              my $sceptre = $refparap{$ARCHIVO}->{sceptrevars}->[$j];
              my $i = $refparap{$ARCHIVO}->{dni}->[$j];
              my $propio = $refparap{$ARCHIVO}->{variables}->[$i-1];
              defined $i or $i = 0;
              not defined $refnombreshashes->{$ARCHIVO}->{$sceptre} and
                 $refnombreshashes->{$ARCHIVO}->{$sceptre} = $i;          
	  };
      };
  }; # for $ARCHIVO
  comfin('fin contr_arch_variables');
  return;
} # contr_arch_variables
# -----------------------------------------------------------------------------
sub contr_graf{
# controla uso previo  e inicializa si hace falta
  comfin('com contr_graf',@_);
  foreach my $grafo (@_) {
      my $grafoori= $grafo;my $grafo = lc($grafoori);
      if (not defined $exigraf{$grafo}){
          $exigraf{$grafo} = 0; $simbografori{$grafo} = $grafoori;
          $titx{$grafo} = $tity{$grafo} = $plf{$grafo} = $mj{$grafo} = '';
          $rx{$grafo} = $ry{$grafo} = ''; 
          $fun{$grafo} = []; $pun_lin{$grafo} =[]; 
          $guardar_graf{$grafo} = $PROPIOASINDIA . "_$grafo";
          $uniabscisa{$grafo} = ''; $uniordenadas{$grafo} = '';
          $usagraf_coma_arch_cols{$grafo} = [];
      };
  };
  comfin('fin contr_graf');
}# contr_graf
# -----------------------------------------------------------------------------
sub contr_graf_arch_cols{
  comfin('com contr_graf_arch_col',@_);
  #se ocupa de una pareja graf,arch en lo que tiene que ver preparando para 
  #titulos y conversion de unidades 
  my ($graf,$arch,$listacol) = @_; 
  my $archp = $archivopadre->{$arch}; #imprescindible si hubo seleccion
  defined $archp  or $archp = $arch;
  my $haycol = $refarch{$archp}->{colposibles};
  if ($opt_hash{graf} > 1 and defined $refparap{$archp}->{variables}) {
      $haycol = @{$refparap{$archp}->{variables}}
  };
  #impr_debug(__LINE__.' sim3 $refnombreshashes',Dumper $refnombreshashes);
  my @cols = split /[\:\,]+/, $listacol;
  map(s/\s//,@cols);
  my @malascols;
  foreach (@cols) {
      next if /^\d+$/ and $_ <= $haycol;
      my $colori = $_;
      $_ ne '0' and $_ = $refnombreshashes->{$archp}->{sanear($_)};
      defined $_ or do{push @malascols, $colori; $_ = -1};
  }; 
  @malascols > 0  and do{
          avnoseent("el pedido del gráfico \"$graf\" de variables
          ".join (' ', @malascols )
                  ." para archivo de nombre simbólico $arch");
 
  };

  my $pricol = $cols[0];
  $pricol >= 0 and $pricol <= $haycol or do{
          avnoseent("el pedido del gráfico \"$graf\", de abscisa
             la columna $cols[0] del archivo de nombre simbólico $arch");
          return [], [@cols];
  }; 
  my @buenascols = grep (do{$_ <= $haycol and $_ >=  0}, @cols); 

      my @colsord = sort {$a <=>$b} (union_conjunto(@cols));
      my $ncol = $colsord[-1];

      my $unidad = $unipri{$archp};
      if (not defined $unidad) {
	  $unidad = $refparap{$archp}->{unidades}->[0];
      };
      if (defined $unidad and defined $unist{lc($unidad)} ){
          $unidad = $unist{lc($unidad)};
      };
      defined $unidad or $unidad = ''; 
  comfin('fin contr_graf_arch_col', $graf,$arch,@cols);
  return [@cols], [@malascols];
} #contr_graf_arch_col
# -----------------------------------------------------------------------------
sub contr_jun{ #NO SE USA?
#    my %juntos;
    map($juntos{$_}++ ,@mostrarjunto);
    if (scalar keys %juntos < scalar @mostrarjunto) {
       avnograv(
     "Hay más de un pedido de mostrarjunto  para un(os) archivos(s)
	 Solo se atenderá al último. Revisar: "
	 . join (' ', 
	     map($simbografori{$_},grep($juntos{$_}>1, keys %juntos))));     
    }  
}#contr_jun
# -----------------------------------------------------------------------------
sub contr_titulos_ejesxy{
  comfin('com contr_titulos_ejesxy',@_);
  my $grafo = $_[0];
  if ($titx{$grafo}) {
      if ($titx{$grafo} =~ /\((\w+)\)/) {$uniabscisa{$grafo} = $1};
      if ($tity{$grafo} =~ /\((\w+)\)/) {$uniordenadas{$grafo} = $1};
      return;
  };
  my @r =   #@r es lista de referencias a ... @cosas
    ($magord{$grafo}, $uniord{$grafo}, $varabsc{$grafo}, $uniabsc{$grafo}
     ,$prig{$grafo},$segg{$grafo}); 
  my @resul; my @cosas = ('magnitud de ordenada','unidad de ordenada'
                          ,'variable para abscisa', 'unidad para abscisa'
                          ,'prig', 'segg');
  unshift @{$uniabsc{$grafo}}, @{$prig{$grafo}};
  unshift @{$uniord{$grafo}}, @{$segg{$grafo}};
  foreach my $reff (@r) {
      my @listita = union_conorden(@$reff); 
      my @listitasel = grep(do{defined $_ and $_ ne '??'},@listita);
      my $nombre = shift @cosas;
      @listitasel or do{push@resul, '';next};
      my $sele = '';
      defined $listitasel[0] and $sele = $listitasel[0]; 
      if ($nombre =~ /^uni/) {
          #$sele = " ($listitasel[0])";
          my @initiempo = grep($unist{$_},@listitasel);
          @initiempo == @listitasel and do{
              @listitasel = ($sele); 
          };
      };
      @listitasel = grep(/\S/,@listitasel);
      @listitasel = union_conorden(@listitasel); 
      @listitasel >1 and  do{
	  my @mayusculas = @listitasel; 
          map(do{$_ = uc($_);$_ =~ s/\s+//g},@mayusculas);
          @mayusculas = union_conjunto(@mayusculas);
          @mayusculas >1 and avnograv("Posibles nombres para  $nombre: 
          @listitasel           se elige $sele");          
      };
      push @resul, $sele;
  };
  $uniabscisa{$grafo} = $resul[3];$uniordenadas{$grafo} = $resul[1];
  $titx{$grafo} = $resul[2]; $resul[3] and $titx{$grafo} .= " ($resul[3])";
  $tity{$grafo} = $resul[0]; $resul[1] and $tity{$grafo} .= " ($resul[1])";
  comfin('fin contr_titulos_ejesxy');
}#contr_titulos_ejesxy
# -----------------------------------------------------------------------------
sub extraer{
   my $texto = $_[0];my @listita = ();
   if ($texto =~ /(.*)\(\s*(\S.*)\s*\)/) {
       my $unidad = $2; my $var = $1; $var =~ s/^\s*//;$var =~ s/\s*$//;
       $unidad = $unist{lc($unidad)}
         if defined $unist{lc($unidad)};# %unist, solo para tiempo
       return $var,$unidad;
   } else {
       return '??','??';
   }    
}#extraer
# -----------------------------------------------------------------------------
sub graficar_pedidos{
  comfin('com graficar_pedidos',@_);
   foreach my $grafo (keys %exigraf) {
      next if defined $juntos{$grafo};
      llenar_desde_arch($grafo,'');
      impr_grafo($grafo,'graficar_pedidos');
      contr_titulos_ejesxy($grafo);
      pun_lin($grafo);
      my $funfun = funciones($grafo);
      $plf{$grafo} = join (",\\\n", @{$pun_lin{$grafo}}, @{$funfun}); 
      next if $juntos{$grafo};
      grafear($grafo);
      if (not defined $nomostrar{$grafo}) {
#          my $impre =  
#" Archivos asociados con  \"$simbografori{$grafo}\": $guardar_graf{$grafo}.gnu\n ";
#        $impre .=  ' ' x 10 . "$guardar_graf{$grafo}.eps   $guardar_graf{$grafo}.png";
#        explic($impre);
    };
  };
  mostrar_juntos() if scalar keys %juntos; 
  my @mensno = grep($exigraf{$_} == 0,keys %exigraf);
  @mensno = map($_ = $simbografori{$_}, @mensno);
  @mensno and avnograv("Nada para poner en los graficos 
        " . join (', ', sort @mensno));
  my @lisnomostrar = grep($exigraf{$_},keys %nomostrar);
  my @lisexigraf = grep($exigraf{$_},keys %exigraf);
  explic('=' x 70);
  if (@lisnomostrar) {
      $archi = $lisnomostrar[0];
  } else {
      $archi = $lisexigraf[0];
  };
  defined $archi or parar3(208,'No quedó nada para graficar');
  my ($ba, $pr,$co) = relativizar("$BASEARCHA$guardar_graf{$archi}",$pwdori);
  explic(
   " --- Los archivos como el $co.gnu pueden editarse;
       y con        gnuplot -persist $co.gnu\n"
             . "     muestran el gráfico y producen:\n" . ' ' x 20 
       .  "$co.eps   $co.png"); 
  my $errorgnuplot = '';
  dibu($PROPIOASINDIA);
  my $renglon = `grep "arch_var SIMULADO" $PROPIOSINDIA.paraplot`;
  chomp $renglon; 
  $renglon =~ s/^arch_var SIMULADO = $archivosinext.simul\,//; 
  my @lisarchsimul = split ',', $renglon;
  if (not system 
        "grep $PROPIOASINDIA.par $PROPIOASINDIA.d >/dev/null 2>/dev/null") {
      system "cat $PROPIOASINDIA.par";
  };
  if (-e "$PROPIOASINDIA.res" and $opt_hash{graf} ne '2'
      and not $opt_hash{noverb}) {
#      system "echo grep RERUN $PROPIOASINDIA.res";
      my @reruns;
      if (not system "grep RERUN $PROPIOASINDIA.res >/dev/null 2>/dev/null") {
          my $rerun = `grep RERUN $PROPIOASINDIA.res`;
          chomp $rerun; $rerun =~ s/^.+RERUN\s.\/(\d).*$/$1/;  @reruns = (1..$rerun);
      }; 
      system "cat $PROPIOASINDIA.res";
      foreach (@reruns) {
          system "cat ${PROPIOASINDIA}_$_.res";
      }; 
  };
  if ($opt_hash{graf} >= 3) {
      my $errorcod = system "./$PROPIOASINDIA.gra 2>gnuplot.ls1";
      system "grep -vi Warning.*empty gnuplot.ls1";
      my @ls1 = `cat gnuplot.ls1`;
      @ls1 = grep(do {$_ !~ /Warning.*empty/},@ls1);
      map(mensaje($_), @ls1);
      explic ("Cierre gráficos con \"q\"; o click en la \"x\"; o ......
             se cerrarán solos la próxima vez que simusol produzca gráficos");
      $errorcod and do{
          avgrav("Ha habido problemas al preparar los gráficos");
	  parar3(50,'');
      };
  } else {
      explic(" Se ha pedido no mostrar gráficos, 
            pero se podrán ver con 
        ./$CORTOASINDIA.gra
	             " . '-' x 15);
  };
  print "\n";
  comfin('fin graficar_pedidos');
} #graficar_pedidos                  
# -----------------------------------------------------------------------------
sub graficar_interact{
  comfin('com graficar_interact',@_);
  my $i=0; my @lisposibles;
  print  '-' x 70,"\n Archivos disponibles para graficar:\n";
  foreach my $simbarch (keys %SIMBOARCHORI) { 
#q      next if $exiarch{$simbarch} < 2;#CUIDADO
      #(defined $refparap{$simbarch}->{variables} 
      #  and @{$refparap{$simbarch}->{variables}} >1) or next;
      $i++;
      printf "   %1s:   %1s\n",  $simbarch, $nombarch{$simbarch}; 
      push @lisposibles, $simbarch;
  }; #foreach 
  my $simbarch = '';   
  if (@lisposibles == 0) {
      parar3(200,'Ningún archivo se puede graficar');
  } elsif ($opt_hash{noverb}) {
      parar3(201,'La opcion "-noverb" impide graficar interativamente');  
  } elsif (@lisposibles > 1) {
      @lisposibles = seleccionar_archivo('','',\@lisposibles);
      print "   Si quiere un gráfico, 
      indíquelo a continuación\n";
  };       
  print "   Si quiere un gráfico con los datos de algunos  de ellos, 
      indíquelo a continuación\n";
  my $ya = '';
  my $ggrafo = $PROPIOASINDIA.'_interact';
  contr_graf($ggrafo);
  $guardar_graf{$ggrafo} = $PROPIOASINDIA.'_interact'; 
  my $haygrafo = '';my @punlin = (); my @pl;
  for (my $j =0; $j < @lisposibles; $j ++) {
      $ya = 1;$haygrafo = '';
      while ($ya eq 1) {
          $ya = pedir_graf($lisposibles[$j],$ggrafo);
          if ($ya =~ /1/) {
              $haygrafo = 1;
              my $coderr = system "gnuplot -persist $ggrafo.gnu"; 
              explic("$ggrafo.gnu, $ggrafo.eps, $ggrafo.png 
                son los archivos correspondientes al gráfico;
                serán sobreescritos la próxima vez .....");
	  } elsif ($ya =~ /2/) {
              grafear($ggrafo);
              $ya = 1;    
	  };
      };
      if (@lisposibles > 1 and $haygrafo) {
          print 'x'x 20," Quiere juntar ese gráfico con otros (s|y|n)? ";
          my $resp = <STDIN>;chomp $resp;
          if ($resp =~ /[sy]/i) {
              push @pl, $plf{$ggrafo};
          };
      };
  }; # for
  if (@pl) {
      my $gacugrafo = $guardar_graf{$ggrafo} = $PROPIOASINDIA.'_interact_acu';
      $plf{$ggrafo} = join ", \\\n",@pl;#para tener generalidades del ultimo
      grafear($ggrafo); 
      my $coderr = system "gnuplot -persist $gacugrafo.gnu"; 
      explic("$gacugrafo.gnu, $gacugrafo.eps, $gacugrafo.png   
              son los archivos correspondientes al gráfico;
              serán sobreescritos la próxima vez .....");
  };
  explic("   no quiso nada más");
  comfin('fin graficar_interact');  
  parar3(206,'');
} #graficar_interact
# -----------------------------------------------------------------------------
sub pedir_graf{
  comfin('com pedir_graf',@_);
  my ($simbarch,$grafo) = @_;
  my (@connumeros,@lisunis);
  print '-' x 20," $nombarch{$simbarch} ", '-' x10, "\n";
  if ($simbarch eq 'SIMULADO') {
      my @res = `cat $PROPIOASINDIA.res`;
      @connumeros = grep (/^..\d/g, @res);
      print join('',@res);
  } else {
      @connumeros = @{$refvarori{$simbarch}};
      @lisunis = @{$refparap{$simbarch}->{unidades}};
      for (my $i = 0; $i < @connumeros; $i++) {
          my $uni = $lisunis[$i];  $uni and $uni ="($uni)";
          printf "%5i: %10s %3s\n", $i+1, $connumeros[$i],$uni;  
      };   
  };
  my $refbuenas;
  my $cuantos = @connumeros;
  my ($absc,@lista);my $biennum = 9;
       my $mensnovalido = "\n" .'X' x 20 
   . " indicación no válida; pida por ejemplo     1, 2\n";
  until ($biennum eq 1) {
       print " Si quiere poner en un gráfico algo de este archivo,
             indique números o nombres de variables  que interesan 
             separados por \",\"   o   \":\" 
               para abscisa y ordenadas:
           (0 para abscisas, si quiere lista de valores;
           simplemente ENTER, si no quiere nada más de este archivo;
            o Control-C para terminar con todo)  "; 
      $absc = <STDIN>;chomp $absc;
      if ($absc =~ /^\s*$/) { # or $absc =~ /^\s*0\s*$/) {
	  return 0;
      };
      if (not $absc =~ s/^\s*([\'\"\s\,\;\:\w]+)\s*$/$1/) {
 	  mensaje($mensnovalido. __LINE__);
          next;
     };
      my ($haycomillas,$cambio,$error) = ('',1,''); 
       print "loliloli $absc\n";
      while ($absc =~ /[\'\"]/ and $cambio and not $error) {
	      print "loliloli entre0\n";
	  $haycomillas = 1;
	  $cambio = '';
          while ($absc =~ /^[^\'\"]*\'([\w\s]+)\'/) {
	      print "loliloli entre1\n";
              my $sust = $refnombreshashes->{$simbarch}->{sanear($1)};
              defined $sust or
	      do {avnoseent(" a que variable se refiere  \'$1\'");
                  $error = 1; last;
              };
              $absc =~ s/^([^\'\"]*)\'([\w\s]+)\'/$1$sust/;
              $cambio = 1;
          };
          while ($absc =~ /^[^\'\"]*\"([\w\s]+)\"/) {
	      print "loliloli entre2\n";
              my $sust = $refnombreshashes->{$simbarch}->{sanear($1)};
              defined $sust or
	      do {avnoseent(" a que variable se refiere  \"$1\"");
                  $error = 1; last;
              };
              $absc =~ s/^([^\'\"]*)\"([\w\s]+)\"/$1$sust/;
              $cambio = 1;
          }; 
      };
      $haycomillas and not $cambio and
      do {
	  mensaje( "$absc ". $mensnovalido.__LINE__);
          next;
       };
      $absc =~ s/\s/,/g; 
      ($refbuenas,my $refmalas) 
           = contr_graf_arch_cols($grafo, $simbarch, $absc);
      
      #@lista =  split(/[\s\,\;\:]+/,$absc);$biennum = 9;
      if (@$refmalas) { 
          mensaje(" $absc ". $mensnovalido);
          next
      } elsif (@$refbuenas == 1) { 
          print 
       "       faltan los números de variables para ordenadas: "; 
          my $orden = <STDIN>;
          chomp $orden;
	  $absc .= ",$orden";
          ($refbuenas,$refmalas) 
              = contr_graf_arch_cols($grafo, $simbarch, $absc);
          @$refbuenas and not @$refmalas and $biennum = 1;
      };
      $biennum = 1 if $biennum; 
  };# until
      $usagraf_coma_arch_cols{$grafo} = [['g_linea', $simbarch, $refbuenas ]];
  my @buenas = @$refbuenas;
  llenar_desde_arch($grafo,'');
  $titx{$grafo} = $tity{$grafo} = $plf{$grafo} = $mj{$grafo} = '';
  $uniabscisa{$grafo} = ''; $uniordenadas{$grafo} = '';
  contr_titulos_ejesxy($grafo);
  %pun_lin = ();
  pun_lin($grafo);
  $plf{$grafo} = join(",\\\n",@{$pun_lin{$grafo}});
  grafear($grafo) if $plf{$grafo};
  comfin('fin pedir_graf');
  return 1;
} #pedir_graf
# -----------------------------------------------------------------------------
sub llenar_desde_arch{
  comfin('com llenar_desde_arch',@_);
  my ($grafo,$modo) = @_; #$modo falso desde vacios.
    my @puntoslineas = @{$usagraf_coma_arch_cols{$grafo}};
    unless  ($modo) {
      $varabsc{$grafo} = [];
      $uniabsc{$grafo} = [];
      $magord{$grafo} = [];
      $uniord{$grafo} = [];
      $prig{$grafo} = [];$segg{$grafo} = []
  };
  foreach my $refrenglon (@puntoslineas) {my $simbarchp;
      my ($comando,$simbarch,$reflista) = @{$refrenglon};
      impr_debug(__LINE__.' sim3 $simbarch',$simbarch);
      if ($archivopadre->{$simbarch}) {
	  $simbarchp = $archivopadre->{$simbarch};
      } else {
          $simbarchp = buscar_padre($simbarch);
      };	  
      next unless @$reflista;   
      my @buenas = @$reflista;
      my $absc = shift @buenas; 
      if ($absc  ne 0) { 
          push @{$varabsc{$grafo}}, $refvarori{$simbarchp}->[$absc-1]; 
          push @{$uniabsc{$grafo}}
              , $refparap{$simbarchp}->{unidades}->[$absc-1];
      } else {
          push @{$varabsc{$grafo}}, 'numero de orden en el archivo';
          push @{$uniabsc{$grafo}}, '';
          unshift @{$prig{$grafo}}, 'numero de orden en el archivo';
      };
      if ($opt_hash{graf} ne 1 and $absc == 1 and defined $unipri{$simbarch}) {
          if ($simbarchp eq 'SIMULADO') {
              unshift @{$prig{$grafo}}, $unipri{$simbarchp};
          } else {
              push @{$prig{$grafo}}, $unipri{$simbarchp}; 
          };
      };
      if (join (' ',(' ',@buenas)) =~ / 1 / and defined $unipri{$simbarchp}) {
          if ($simbarchp eq 'SIMULADO') {
              unshift @{$segg{$grafo}}, $unipri{$simbarchp};
          } else {
              push @{$segg{$grafo}}, $unipri{$simbarchp}; 
          };
      };        
      map (do{push @{$magord{$grafo}}
              , $refparap{$simbarch}->{magnitudes}->[$_ -1]},@buenas);
      map  (do{push @{$uniord{$grafo}}
                      , $refparap{$simbarch}->{unidades}->[$_ -1]},@buenas);
  };
  my ($pg,$sg) = ($uniabsc{$grafo}->[0],$uniord{$grafo}->[0]);
    @{$prig{$grafo}} and $pg = $prig{$grafo}->[0];
  @{$segg{$grafo}} and $sg = $segg{$grafo}->[0];
  comfin('fin llenar_desde_arch');
}#llenar_desde_arch  
# -----------------------------------------------------------------------------
sub grafear{
  comfin('com grafear',@_);
  my $grafo = $_[0];
  if ($juntos{$grafo}) {
      comfin('fin grafear linea',__LINE__);
      return;
  };    
  if ($plf{$grafo}) {
      $exigraf{$grafo} = 1;
  } else {
      comfin('fin grafear linea',__LINE__);
      return;
  }
  my ($panta1,$impre1) = ('','');
  $panta1 = $impre1 = "set title '$titulograf{$grafo}'\n"
    if defined $titulograf{$grafo} && $titulograf{$grafo} ne '';
  $panta1 .= "set xlabel '$titx{$grafo}'\n" 
    if defined $titx{$grafo} && $titx{$grafo} ne '';
  my $titlejey = '';
  defined $tity{$grafo} and $titlejey = $tity{$grafo}; 
  #Hay que poner titulo al eje y aunque sea vacio porqe de otro modo
  #para grafos multiples el segundo puede copiar titulo del primero

  $panta1 .="set ylabel '$titlejey'\n";
  $archi = $guardar_graf{$grafo};
  my $rangos;
  if ($rx{$grafo} eq '' and $ry{$grafo} ne '') {
      $rangos = "[] $ry{$grafo}";
  } else {
      $rangos = $rx{$grafo}.$ry{$grafo}; 
  };
  open ESTE,">$archi.gnu" or die "No puedo crear $archi.gnu\n";
  $todo{$grafo} = $panta0. $panta1. "plot $rangos\\\n$plf{$grafo} \n"; 
  my $size = 1; $size = 0.7 if $opt_hash{graf} eq '5';
  print ESTE "\# archivo $guardar_graf{$grafo}.gnu $mensaje_comienzo ";
  print ESTE "$guardar_graf{$grafo}.gnu\n";
  if (defined $nomostrar{$grafo}) {
      print ESTE "#  (   Para ver buen grafico en pantalla, cambie\n";
      print ESTE "#     set term dumb    por   set term X11     )\n"; 
      print ESTE "set term dumb\n";
  } else {
      print ESTE "set term X11\n";
  };
  print ESTE "set size $size,$size\nset origin 0.0 ,0.0\n";
  print ESTE $todo{$grafo};
  foreach ('eps','png') {
      print ESTE "set term $term{$_}\nset output '$archi.$_'\nreplot\n";
  };
  close ESTE;
  comfin('fin grafear linea',__LINE__);
  return
} 
# -----------------------------------------------------------------------------
sub mostrar_juntos{
  comfin('com mostrar_juntos',@_);
  my $size = 1; $size = 0.7 if $opt_hash{graf} eq '5';
  foreach my $grafj (keys %juntos) {
      defined $guardar_graf{$grafj} or
      do {$guardar_graf{$grafj} = $grafj;
          $noarchresori{$grafj} = 1;
      };
      open ESTE,">$guardar_graf{$grafj}.gnu" 
          or die "No puedo crear $guardar_graf{$grafj}.gnu\n";
      my @graf = @{$juntos{$grafj}};
      @graf = grep($exigraf{$_},@graf);
      if (@graf == 0) {
          $exigraf{$grafj} = 0;
          next;
      }; 
      print ESTE "\# archivo $guardar_graf{$grafj}.gnu $mensaje_comienzo ";
      print ESTE "$guardar_graf{$grafj}.gnu\n";
      print ESTE "set term X11\nset size $size,$size\nset origin 0.0 ,0.0\n";
      my $multiplot = "set multiplot\nset lmargin 11\nset bmargin 1\n";
      print ESTE "$multiplot";
      my $cuantos = scalar @graf;
      my $altura = $size*0.90/$cuantos; 
      my $textografo = '';
      for (my $i = 0; $i < $cuantos; $i ++) { #solo se espera $cuantos  2 
          my $grafo = $graf[$i];
          next if not defined $todo{$grafo};
          my $texto = "$todo{$grafo}";
          my @lista = split(/\n/,$texto); 
          my $yorigen = $size - ($i+1) * $altura;
          $textografo .= "set size $size,$altura\nset origin 0.0 ,$yorigen\n";
          foreach(@lista) {
	      next if /set xlabel/ and $i != $cuantos-1;
	      next if /set term/ ;
              last if /term postcript/;
              $textografo .= "$_\n"; 
          };
      };   
      print ESTE $textografo;
      print ESTE "set nomultiplot\n"
       ."reset\n";
      foreach my $tipograf ('eps','png') {
          print ESTE "set term $term{$tipograf}
set output \'$guardar_graf{$grafj}.$tipograf\'\n";
          print ESTE $multiplot, $textografo, "set nomultiplot
reset\n";
      };
      close(ESTE);				
#      my $impre =  
#   " Archivos asociados con  \"$simbografori{$grafj}\": $guardar_graf{$grafj}.gnu ";
#      $impre .= "\n" . ' ' x 10 . 
#        "$guardar_graf{$grafj}.eps   $guardar_graf{$grafj}.png";
#      explic($impre);
      $exigraf{$grafj} = 1;      
  };
  comfin('fin mostrar_juntos');
} 
# -----------------------------------------------------------------------------
sub dibu{ #llena el archivo .gra con lo necesario 
  comfin('com dibu',@_);
  my $archivo = $_[0];
  open DIBUJAR,">$archivo.gra" 
      or parar3(210,"No se puede escribir $archivo.gra");
  foreach my $grafo (sort keys %exigraf) {
      next unless $exigraf{$grafo};
      my $mens = '';
      my $archi = $guardar_graf{$grafo};
      if (defined $mensajegra{$grafo}) {
          $mens = "\"$mensajegra{$grafo}\""; 
          print DIBUJAR "echo $mens\n";
      }; 
      if ($nomostrar{$grafo}) {
          print DIBUJAR "gnuplot $archi.gnu >/dev/null\n";
      } else {
	  print DIBUJAR "gnuplot -persist $archi.gnu\n";
      }
      print DIBUJAR "RCODE=\$RCODE\$?\n";
  };
  print DIBUJAR "exit \$RCODE\n";
  close DIBUJAR;
  system "chmod a+x $archivo.gra";
  comfin('fin dibu');
}
# -----------------------------------------------------------------------------
sub contr{ 
  comfin('com contr'); # no tiene argumentos
  # controla relacion entre grafos y los archivos que los contendran
  for my $grafo (keys %exigraf){
      my %funfun; $funfun{$grafo} = [];
      foreach my $reff (@{$fun{$grafo}}) {
          my @lisf = @$reff;
          @lisf > 2 and avnoseent("funcion @lisf; se ignora");
          @lisf == 2 and 
               push @{$funfun{$grafo}},"$lisf[0] title \'$lisf[1]\'";
          @lisf == 1 and 
               push @{$funfun{$grafo}},"$lisf[0]";         
     };
      $plf{$grafo} = join (",\\\n", @{$pun_lin{$grafo}}, @{$funfun{$grafo}}); 
      if ($plf{$grafo} eq '' and $mj{$grafo} eq '') {
          $exigraf{$grafo} = 0;
          next;
      } elsif ($plf{$grafo} ne '' and $mj{$grafo} ne '') {
          avnograv("No son posibles los pedidos para $simbografori{$grafo};
        resultan incompatibles:
            $plf{$grafo}   
            mostrarjuntos  $mj{$grafo}.........
        Se ignorarán");
	  $exigraf{$grafo} = 0;
	  next
      };
    $archi = $guardar_graf{$grafo}; 
      if (not defined $archi) {
          $guardar_graf{$grafo} = $PROPIOASINDIA . "_$grafo";
          $noarchresori{$grafo} = 1;
      };
  };
  my @grafos = keys %noarchresori;
  if (@grafos) {  
      my $mens = ' ' x 15 .
            "guardar $simbografori{$grafos[-1]} = $guardar_graf{$grafos[-1]}\n";
      explic(" Ud. puede elegir nombres para los archivos que
                   guardarán los gráficos, agregando al cuadro GRAFICOS
		   renglones similares a: (para opción por defecto)\n"
           . $mens);
  };    
  comfin('fin contr');

}# contr
# -----------------------------------------------------------------------------
sub guardar_renglones{#REVISAR
  comfin('com guardar_renglones',@_);
  # interpreta y guarda cada renglon (ampliado) de pedido de puntos o lineas
  # nombre simbólico de archivo en mayúsculas;
  # nombre simbólico de gráfico en minúsculas
  # Los guarda en @puntoslineas,  %archres, %variaciones;
  my @pedidos = @_;

  #print Dumper [@pedidos];
  
  map(s/(\W)CALCULADO/$1SIMULADO/,@pedidos); 
  my @SIMULADOs; map(do{/\W(SIMULADO\w+)/ and push(@SIMULADOs,$1)},@pedidos);
  my $reg_arch = 
   'archivo|variable|magn|indice|sceptre|todo|unidad|selec|unipri'
     . '|variacion|arch_var';
  my $reg_graf = '(titulo|eje|guarda|mostrarjunto|eco|rangox|rangoy)';
  my $reg_graf_arch = '(punto|linea|funcion)';
  my $reg_obsoletos = '(crear|extension)';
  my $reg_varios = 'nomostrar';
  my @pedidos_arch = grep(/^($reg_arch)/i,@pedidos);
  my @pedidos_graf = grep(/^($reg_graf)/i,@pedidos);
  my @pedidos_graf_arch = grep(/^($reg_graf_arch)/i,@pedidos);
  my @pedidos_obsoletos = grep(/^($reg_obsoletos)/i,@pedidos);
  my @pedidos_varios = grep(/^($reg_varios)/i,@pedidos);
  @pedidos_arch + @pedidos_graf + @pedidos_graf_arch + @pedidos_varios ==
    @pedidos or do {
	my @pedidoserror = grep(do{ not
        /^$reg_arch|$reg_graf|$reg_graf_arch|$reg_obsoletos|$reg_varios/}
         , @pedidos);
	avnoseent("los pedidos\n" . join("\n       ",@pedidoserror));
  };
  foreach my $pedido (@pedidos_arch) {
      my $renglon = $pedido;
      $renglon =~ s/^ +//;
      my $comando ='';
      my ($reflistai,$sepa,$reflistad,$listad) = parser(@separadores,$renglon);
      # @separadores tiene exactamente tres elementos: inicial ,medio, final
      #que son identif. para patrones
      $reflistai  eq 'error' and do{ 
          avnoseent("$pedido\n         como pedido de gráfico ");next;
      };
      my ($descrip,$simbolo) = @$reflistai;
      $descrip =~ /^($reg_arch)/i;
      $comando = "A_$1"; 
      $SIMBOARCHORI{uc($simbolo)} = $simbolo
	  if not defined $SIMBOARCHORI{uc($simbolo)};
      $simbolo = uc($simbolo); 
      if ($comando eq 'A_variacion') {
          push @{$refparap{$simbolo}->{variaciones}}, $reflistad;
      } elsif ($comando eq 'A_arch_var') {
          push @{$refparap{$simbolo}->{arch_var}}# en guardar_renglones
                , $reflistad;
	  push @{$nombrearch{$simbolo}}, $reflistad->[0];
          foreach(my $i = 1; $i < @$reflistad; $i ++) {
	      push @{$nombrearch{$simbolo ."_$i"}}, $reflistad->[$i];
          };
     } elsif ($comando eq 'A_unipri') {
          $unipri{$simbolo} = $listad;  
      } elsif ($comando eq 'A_archivo') {
           push @{$nombrearch{$simbolo}}, $listad;
      } elsif ($comando eq 'A_variable') {
          @{$refvarori{$simbolo}} = @$reflistad;   
          for (my $i=1;$i<@$reflistad+1; $i++) {
              $reflistad->[$i-1] eq '_' and $reflistad->[$i-1] = "col_$i";
          };
          $refparap{$simbolo}->{variables} = $reflistad;
      } elsif ($comando eq 'A_magn') {
          $refparap{$simbolo}->{magnitudes} = $reflistad;
          map(do{$_='' if $_ eq '_'},@$reflistad);
      } elsif ($comando eq 'A_indice') {
          $refparap{$simbolo}->{ind} = $reflistad;
      } elsif ($comando eq 'A_sceptre') {
          $refparap{$simbolo}->{sceptrevars} = $reflistad;
      } elsif ($comando eq 'A_selec') {
          push @{$selec{$simbolo}}, $reflistad;
      } elsif ($comando eq 'A_unidad')  { 
          if ($listad =~/:/) {
              mejorar($renglon); #no hace nada para este proceso,
              # pero escribe, si hace falta,  un archivo traducido
              # que usará después
          };    
          $renglon =~ s/..:..:../segundos/g;
          ($listad) = $renglon =~ /=\s*(.+\S)\s*$/;
          my @listad = split /\s*,\s*/,$listad;
          map(do{$_='' if $_ eq '_'},@listad);
          my (@listadbuena,@lisfactores);
          foreach my $parte (@listad) {
              my $factor = 1;
              if ($parte =~ s/^(\S*)\s+(\S.*)$/$2/) {
                  my $valor = eval($1);
                  # en valor se tendría el factor por el que 
                  # hay que multiplicar los números  
                  # para obtenerlos  en las unidades deseadas
                  if (defined $1 and not defined $valor) {
                      avnoseent( $1. " en \"$listad\" como un factor"); 
	          };
                  defined $valor and $factor = $valor;
              };
              push(@listadbuena, $parte);
              push(@lisfactores, $factor);
          };
          $refparap{$simbolo}->{unidades} = \@listadbuena;
          $reffactor{$simbolo} = \@lisfactores;
      };
  };


  #print Dumper  \%refparap;
  #exit;


  
  impr_debug(__LINE__.' sim3 %SIMBOARCHORI',\%SIMBOARCHORI);
  impr_debug(__LINE__.' sim3 %nombrearch',Dumper \%nombrearch);
  my $refarchposibles = leer_info_archivos(keys %SIMBOARCHORI);
  my $refparposibles = contr_archivos_paraplot($refarchposibles);
  completar_nombres($refparposibles) if @$refparposibles;
  contr_sobre_archivos($refparposibles); 
  #los que tienen SIMULADO como parte de su nombre

  foreach my $pedido (@pedidos_varios) {
      my $renglon = $pedido;
      if ($renglon =~ s/^\s*nomostrar\s+([^=]+)$/$1/i) {
          $renglon =~ s/\s*$//;
          my @nolista = split ('\s*,\s*',$renglon);
          map( $nomostrar{lc($_)} = 1, @nolista); 
      }; 
  };
  if (@pedidos_obsoletos) {
      avnograv('Los  pedidos "crear" o "extension" son obsoletos;
                los archivos de extension ".png" se producen siempre');
  };
  my @listagrafos;
  map (do{/^\w+\s+(\w+)/ and push @listagrafos,lc($1)}
       ,(@pedidos_graf, @pedidos_graf_arch));
  contr_graf(@listagrafos);
  foreach my $pedido (@pedidos_graf, @pedidos_graf_arch ) {
      my $renglon = $pedido;
      $renglon =~ s/^ +//;
      my ($comando,$mens) = ('','');
      my ($reflistai,$sepa,$reflistad,$listad) = parser(@separadores,$renglon);
      # @separadores tiene exactamente tres elementos: inicial ,medio, final
      #que son identif. para patrones
      $reflistai  eq 'error' and  
         avnoseent("el pedido  para graficar
                   $pedido");
      my ($descrip,$simbolo) = @$reflistai;
      $descrip =~ /^($reg_graf)/i or $descrip =~ /($reg_graf_arch)/i; 
      $comando = "g_$1";
      $simbolo = lc($simbolo); 
      if ($comando eq 'g_titulo'){$titulograf{$simbolo} = $listad;
      } elsif ($comando eq 'g_rangox') {$rx{$simbolo} = rango($listad);
      } elsif ($comando eq 'g_rangoy') {$ry{$simbolo} = rango($listad);
      } elsif ($comando eq 'g_funcion') {push @{$fun{$simbolo}}, $reflistad;
      # gnuplot le pone como título la definición de la función; salvo
      #que se le de un título
      } elsif ($comando eq 'g_guarda') {
          if ( @$reflistad == 1) {
              $guardar_graf{$simbolo} = $reflistad->[0];
              $guardar_graf{$simbolo} = $reflistad->[0];
          } else {
           avnoseent("el pedido de guardar
                     $pedido");
          }
      } elsif ($comando eq 'g_eje') {
          my ($coderr,@lisd) = juntar_por_paren(',',@$reflistad);
          if (@lisd != 2) {
              avnoseent(join(',',@lisd) . " como parte de indicación para ejes
                   pueden resultar gráficos erroneos
          Se espera, por ej.,  \"ejes xxxx = tiempo(seg), temp(grados C)\"");
          } else {
              $titx{$simbolo} = $lisd[0];# por eje
              $tity{$simbolo} = $lisd[1];# por eje
              (my $varabsc,$uniabscisa{$simbolo})
                   = extraer($lisd[0]); # por eje
              (my $magord,$uniordenadas{$simbolo}) 
                   = extraer($lisd[1]);#por eje
          };
      } elsif ($comando eq 'g_punto' or $comando eq 'g_linea') {
#	  impr_debug(__LINE__.' sim3 $listad',$listad);
	  my @listad = split /\s*[,:]\s*/,$listad;
	  if (@listad >= 3) {
              my $simbarch = uc(shift @listad); my $exi = $exiarch{$simbarch};
	      if (not defined $exi or $exi < 2) {
                  avnoseent("el pedido: $pedido  
                  usa archivo de nombre simbolico $simbarch no declarado");
	      } else {
		  my $cols = join ',',@listad;
#		  my $simbarchp = ($archivopadre->{$simbarch} or $simbarch);
                  my ($refbuenas,$refmalas) 
		      = contr_graf_arch_cols($simbolo, $simbarch, $cols);
		  if (@$refmalas == 0) {
                      push @{$usagraf_coma_arch_cols{$simbolo}}
                        , [$comando, $simbarch, $refbuenas] if @$refbuenas >1;
                  }; 
             };
          } else {
	      impr_debug(__LINE__.' sim3 $comando $listad'
			 ,[$comando,'||',$listad]);
              avnoseent("el pedido del gráfico \"$simbolo\":
                  $pedido");
          };
      } elsif ($comando eq 'g_mostrarjunto'){
          defined $juntos{$simbolo} and
              parar3(40,
              "En el archivo $CORTOSINDIA.paraplot hay más de una sentencia
                mostrarjuntos $simbolo");
          $juntos{$simbolo} = $reflistad;
          map($_ = lc($_),@$reflistad); 
          push @mostrarjunto, $simbolo;
          $mj{$simbolo} = '(' . join (',',@$reflistad) .')';       
      } elsif ($comando eq 'g_eco') {
          $pedido =~ s/^[^=]+=//;
          $mensajegra{$simbolo} .= "$pedido\n";
     };
  };
  impr_debug(__LINE__.' sim3 %usagraf_coma_arch_cols'
	     ,Dumper \%usagraf_coma_arch_cols);
  comfin('fin guardar_renglones');
}# guardar_renglones   
# -----------------------------------------------------------------------------
sub rango{
  use warnings  FATAL => qw(numeric uninitialized);
  my $rango = $_[0]; my ($uno,$dos); my $dif = '';
  if (($uno,$dos) = $rango =~ /^\s*(\S*)\s*:\s*(\S*)\s*$/) {
      $uno ne '' and $uno = eval($uno);
      $dos ne '' and $dos = eval($dos);
      $uno ne '' and $dos ne '' and $dif = eval($dos-$uno);
      (defined $uno and defined $dos and defined $dif 
        and ($dif eq '' or $dif > 0)) 
        or do{
            avnoseent("$rango para indicar un rango");
            return '';
        };	   
      return "[$uno:$dos]"
  };  
  avnoseent("$rango para indicar un rango");
  return '';  
}# rango    
# -----------------------------------------------------------------------------
sub mejorar{
  comfin('com mejorar',@_);
  #copia un archivo sobre otro xxxx.mejor, 'mejorandolo'
  my $renglonant = $_[0];
  if (not $renglonant =~ /\s*(\S+)\s*=\s*(.+)/ ) {
      return;
  } else{
      my  ($simbarch, $resto) = ($1, $2);
      my $nomarch = $nombrearch{$simbarch}->[-1];

      ($resto !~ /yy.mm.dd/i and $resto !~ /hh.mm.ss/i) and return; 
      my @listunis = split(/\s*,\s*/,$resto);
      my (%funcion,@ies)=();my $salto = 24 * 3600;my $ii;
      for (my $i = 0; $i < @listunis; $i++)  {
          if ($listunis[$i] =~ /hh.mm.ss/) {
              $funcion{$i} = '$x1 * 3600 + $x2 * 60 + $x3 ';
	      push(@ies,$i);$ii=$i;$listunis[$i] = 'segundos';
	      last; 
              #REVISAR no se espera mas que un $ii	    
	  };
      };
      my $nommejor = $nomarch . '.mejor';
      $nombrearch{$simbarch}->[-1] =  $nommejor;
      my @listanomarch = stat($nomarch);
      my ($renglon,@listaval,$resul, $resulant);
      if (-e $nommejor) {
          my @listanommejor = stat($nommejor);  
          if ($listanomarch[9] 
	        and $listanomarch[9] gt $listanommejor[9] ) { 
          } else {
              explic("El archivo $nommejor es posterior al $nomarch
            No se recalcula; se usa el existente; "); 
              return;
	  };
      };
      if (not -e $nomarch) {
          avnograv(__LINE__." No existe el archivo $nomarch;
            no se puede preparar el $nommejor");
          return 105;
      }; 
      mensaje ("Archivo $nommejor; lo crearemos ahora a partir del $nomarch"); 
      open (ARCHDAT,$nomarch);
      open (ARCHDATMEJOR,">$nommejor") or die "Np puedo crear $nommejor\n";
      $renglon = <ARCHDAT>;
      my $sigue = 1;
      while ($sigue and $renglon =~ /\s*\#/ ) {
          $renglon = <ARCHDAT>;
	  $sigue = 0 unless $renglon;
      };	  
      @listaval = split(/\s+/,$renglon);
      interpr_hhmmss(\@listaval,$ii,\%funcion);
      $resul = $listaval[$ii];      
      $salto = - $resul;
      $listaval[$ii] = 0;$resulant = $resul;
      impre_renglones(\@listaval);
      while ($renglon = <ARCHDAT>) {
	  next if $renglon =~ /\s*\#/;
	  next if $renglon =~ /^\s*$/;
          @listaval = split(/\s+/,$renglon);                  
	  interpr_hhmmss(\@listaval,$ii,\%funcion);
	  $resul = $listaval[$ii];
	  if ($resul < $resulant) {
              $salto += 24*3600;
	  }; 
	  $listaval[$ii] = $resul + $salto;
	  $resulant = $resul;
	  impre_renglones(\@listaval)
      }
      close (ARCHDATMEJOR);close(ARCHDAT);
  };
  
}
# -----------------------------------------------------------------------------
sub impr_grafo{
  $Data::Dumper::Indent = 0;
  my ($grafo,$mensaje) = @_;
  my $grafotext = "impr_grafo: $mensaje                       $grafo\n";
  if ($juntos{$grafo}) {
      $grafotext.=' ' x 10 . "\$juntos{$grafo} = @{$juntos{$grafo}}\n";
      return;
  };
  $grafotext.=' ' x 10 . '$titx '. $titx{$grafo} .' $tity '."$tity{$grafo}\n";
  $grafotext.=' ' x 10 . '$rx '. $rx{$grafo} .' $ry '. "$ry{$grafo}\n";
  $grafotext.=' ' x 10 . '$usagraf_coma_arch_cols '
      . Dumper($usagraf_coma_arch_cols{$grafo})."\n";
  $grafotext.=' ' x 10 . 'guardar_graf '. "$guardar_graf{$grafo}\n";
  if ($plf{$grafo}) {
      $grafotext.=' ' x 10 . '%plf '.  $plf{$grafo}."\n"  if $plf{$grafo};
  } else {
      $grafotext.=' ' x 10 . '$mj '. "$mj{$grafo} \n";
      $grafotext.=' ' x 10 . '%uniabsc '. Dumper($uniabsc{$grafo})."\n" ;
      $grafotext.=' ' x 10 . '%varabsc '. Dumper($varabsc{$grafo})."\n";
      $grafotext.=' ' x 10 . '%uniord '. Dumper($uniord{$grafo})."\n" ;
      $grafotext.=' ' x 10 . '%magord '. Dumper($magord{$grafo})."\n" ;
      $grafotext.=' ' x 10 . '%prig '. Dumper($prig{$grafo})."\n" ;
      $grafotext.=' ' x 10 . '%segg '. Dumper($segg{$grafo})."\n" ;
      $grafotext.=' ' x 10 . '$uniabscisa '. "$uniabscisa{$grafo}\n" ;
      $grafotext.=' ' x 10 . '$uniordenadas '. "$uniordenadas{$grafo}\n" ;  
  };
  $Data::Dumper::Indent = 1;
  impr_debug(__LINE__.' sim3',$grafotext);
}#impr_grafo
# -----------------------------------------------------------------------------
sub impre_renglones{
    my $reflistaval=$_[0];
    foreach (@$reflistaval) {
        printf ARCHDATMEJOR  "%7s ", $_;
    }
    print ARCHDATMEJOR  "\n";
}# impre_renglones
# -----------------------------------------------------------------------------
sub interpr_hhmmss{
   my ($reflistaval,$ii,$reffun) = @_;
# por ahora solo tiene sentido una columna de valores de tiempo  hh:mm:ss 
          my $resul;
          my $valin = $reflistaval->[$ii];
	  $valin =~ /(.{1,2}).(..).(..)/ 
	        or die 'simusol3.pl: interpr_hhmmss: que pasa ';
	  my ($x1,$x2,$x3) = ($1,$2,$3);
	  $resul = eval ($reffun->{$ii});
	  $reflistaval->[$ii] = $resul;
}# interpr_hhmmss
# -----------------------------------------------------------------------------
sub leer_paraplot3{
  comfin('com leer_paraplot3',@_);
  my $archpar = $_[0];
  open ENTRADA,  $archpar or parar3(12,"No existe el archivo $archpar");
  my @renglones = <ENTRADA>;
  chomp @renglones;
  map(s/\#.*//, @renglones); 
  @renglones = grep (/\S/,@renglones);
  my @renglonespegados;  
  while (@renglones) {
      my $renglon = shift @renglones; 
      next unless $renglon =~ /\S/;
      $renglon =~ s/^\s+//; $renglon =~ s/\s+$//; $renglon =~ s/\s+=\s+/=/;
      my $pega =' ';
      $pega = "\n" if $renglon =~ /^\s*eco/;
      while (@renglones and $renglones[0] !~ /^[\s\w]+=/ 
             and $renglones[0] !~ /^\s*nomostrar/i
             and $renglones[0] !~ /^\s*crear/i   #obsoleto
             and $renglones[0] !~ /^\s*extensi/i #obsoleto
            ) {                
          $renglon .= "$pega$renglones[0]";
          shift @renglones;
      }; 
      push @renglonespegados, $renglon;
  };
# impr_debug(__LINE__.' sim3 @renglonespegados',Dumper \@renglonespegados);
  guardar_renglones(@renglonespegados);
#  impr_debug(__LINE__.' sim3 %SIMBOARCHORI',\%SIMBOARCHORI);
  foreach my $ARCHIVO (keys %SIMBOARCHORI) {
      my $refparapARCH = $refparap{$ARCHIVO};
      if (not defined $refparapARCH->{variaciones} and
          defined $refparapARCH->{arch_var} ) {
	  my @lista = (); my @listaarch = @{$refparapARCH->{arch_var}};
          for (my $j = 0; $j < @listaarch; $j++) {
	      push @lista, "($j)";
          };
          $refparapARCH->{variaciones} = [@lista];
      };
  }; 
  close ENTRADA;
  comfin('fin leer_paraplot3 keys %exiarch %exigraf', keys %exiarch, ' ',keys %exigraf);
}#leer_paraplot3
# -----------------------------------------------------------------------------
sub sanear { #saca espacios y pone mayusculas
    my $col = $_[0];
    $col =~ s/\s*//g; 
    return uc($col);
}
# -----------------------------------------------------------------------------
sub seleccionar_filas{#selecciona_filas
  comfin('com seleccionar_filas',@_);  
  my ($SELEC_ARCHIVO,@lista) = @_; 
  impr_debug(__LINE__.' sim3',\@lista);
  my $archp = shift @lista; 
  impr_debug(__LINE__.' sim3 nombarch',Dumper \%nombarch);
  my $nombre_real_padre = my $selec_nombrereal = $nombarch{$archp};
  impr_debug(__LINE__.' sim3 $selec_nombrereal',$selec_nombrereal);
  my $colo = shift @lista; my ($minimo,$maximo) = @lista;
  my $col = $refnombreshashes->{$archp}->{sanear($colo)};
  defined $col or do{avnoseent("$colo  en @lista"); return};
  $col = $refparap{$archp}->{ind}->[$col-1];
  @lista == 2  and do{
      $minimo <= $maximo or swap($minimo,$maximo);
  } or do{
      avnoseent("Sintaxis incorrecta, seleccionar $SELEC_ARCHIVO = @lista");
      return;
  };
  my $agre = '_'.lc($colo)."_$minimo"."_$maximo";
  $selec_nombrereal =~ s/\.simul/$agre.simul/;
  $nombarch{$SELEC_ARCHIVO} = $selec_nombrereal;
  impr_debug(__LINE__.' sim3 %nombarch',Dumper \%nombarch);
  my $selec_marca = '('.lc($colo) ."=$minimo:$maximo".')';
  $marca{$selec_nombrereal} = $selec_marca;
  impr_debug(__LINE__.' sim3 %marca',Dumper \%marca);
  open NUEVO, ">$selec_nombrereal" or die "No puedo crear $selec_nombrereal\n";
  open VIEJO, $nombre_real_padre;
  my @listaval;
  my $cuantos;
  while (<VIEJO>) {
      /\s*\#/ and do{print NUEVO $_;next};
     my $limpio = ''; my @listaval;
     if (/^\s*(\S.*)$/) {$limpio = $1};
     if ($limpio) {
         @listaval = split /\s*[\s\,]\s*/,$limpio;
         my  $key = $listaval[$col-1];
	 $key > $maximo and last;
         $minimo < $key  and 
             print NUEVO $_;
     };
     $cuantos ++;  
  };
  close VIEJO; close NUEVO;
  explic("$cuantos renglones copiados"); 
  $archivopadre->{$SELEC_ARCHIVO} = $archp;
  $exiarch{$SELEC_ARCHIVO} = $exiarch{$archp};
  $nombarch{$SELEC_ARCHIVO} = $selec_nombrereal;
#  push @{$nombrearch{"$SELEC_ARCHIVO"}}, $selec_nombrereal;
  comfin('fin seleccionar_filas');
  return;
}#seleccionar_filas
# -----------------------------------------------------------------------------
sub funciones{
  comfin('com funciones',@_);
  my ($grafo) = @_;
  my $funfun = [];
  foreach my $reff (@{$fun{$grafo}}) {
      my @lisf = @$reff;
      @lisf > 2 and avnoseent("funcion @lisf; se ignora");
      @lisf == 2 and 
           push @{$funfun},"$lisf[0] title \'$lisf[1]\'";
      @lisf == 1 and 
           push @{$funfun},"$lisf[0]";         
  };
  comfin('fin funciones',@$funfun);
  return $funfun;
}
# -----------------------------------------------------------------------------
sub pun_lin{
  comfin('com pun_lin',@_);
  my ($grafo) = @_;
  foreach my $refrenglon (@{$usagraf_coma_arch_cols{$grafo}}) {
      my ($comando,$ARCHIVO,$listacol)= @$refrenglon;
      my $ARCHIVOP = $archivopadre->{$ARCHIVO};
      defined $ARCHIVOP or $ARCHIVOP= $ARCHIVO;
      my @listacol = @$listacol;  
      my ($pri,$titulo,$factorpri);
      $pri = shift @listacol; my $priajus = $pri;
      my $uniabscisa = $uniabscisa{$grafo};
      $priajus = ajustar_uni($ARCHIVOP,$uniabscisa,$pri) if $pri >0; 
      my $with; 
      $comando eq 'g_linea' and $pri > 0 and $with = ' with lines'
        or $with = 'with points';
      my %ajus;
      for (my $i = 0; $i < @listacol; $i ++) {
          $ajus{$listacol[$i]} = 
              ajustar_uni($ARCHIVOP,$uniordenadas{$grafo},$listacol[$i]);
      };
      my $simbolosust = $nombarch{$ARCHIVO};
      my @listasust; #my @marcas = ('');
      if ($selec{$ARCHIVO}) {
	  @listasust = ($nombarch{$ARCHIVO});
      } elsif (defined $refparap{$ARCHIVO}->{arch_var}) {  
          @listasust = @{$refparap{$ARCHIVO}->{arch_var}};
      } else {
	  @listasust = ($nombarch{$ARCHIVO});
      };	  
      my $i = 0;
      foreach my $simbolosust (@listasust) {
          foreach my $seg (@listacol){
              my ($alguito,$titulo);
              $titulo =  "col_$seg";
              if (defined $refparap{$ARCHIVOP}->{variables}) {          
                $titulo = $refvarori{$ARCHIVOP}->[$seg-1] 
	      };
              $alguito = 
                 "'$simbolosust' using $priajus:$ajus{$seg} ";  
              defined $marca{$simbolosust} or $marca{$simbolosust} = ''; 
              $alguito .= "title '$titulo $marca{$simbolosust}' $with";
              push @{$pun_lin{$grafo}}, $alguito;
          }; # foreach $seg @listacol
          $i++;
       };# foreach  @listasust
  };# foreach @$usagraf_coma_arch_cols 
 comfin('fin pun_lin');
} #pun_lin
# -----------------------------------------------------------------------------
sub ajustar_uni{
   comfin('com ajustar_uni',@_);
   my ($ARCHIVO,$unigrafico,$indicevar) = @_;
   #$indice se refiere a variables propias, $indicesceptre a var.sceptre.
   #ambos a partir de 1;
   my $indicesceptre = $refparap{$ARCHIVO}->{ind}->[$indicevar-1];
   defined $indicesceptre or $indicesceptre = $indicevar;
   defined $unigrafico and $unigrafico eq '??' and return $indicesceptre; 

   my ($refu,$reffac) = ($refparap{$ARCHIVO}->{unidades}
                         , $reffactor{$ARCHIVO});
   my $unitarchivo = $unist{lc($refu->[$indicevar-1])};
   my $unitgrafico = $unist{$unigrafico};
   # %unist, con abreviaturas de unidades para tiempo
   # %factort facores para convertir unidades de tiempo
   my $fac = $reffac->[$indicevar-1]; #no se usa intencionalmente para Tiempo 
   $fac or $fac =1;
   #si $uniarchivo no esta definido, no se ha previsto ninguna conversion
   if (defined $unitarchivo && defined $unitgrafico &&
     defined($factort{$unitgrafico}) && defined($factort{$unitarchivo})) {
       $fac = $fac * $factort{$unitarchivo}/$factort{$unitgrafico}
   };
   comfin('fin ajustar_uni', $indicesceptre, $fac);
   $fac == 1 and return $indicesceptre
      or do{
          $fac = sprintf "%6.4g",$fac;
	  return  "\(\$$indicesceptre\*$fac\)"; 
   };
}# ajustar_uni

# -----------------------------------------------------------------------------
sub parar3{
  if ($_[1]) {
      avgrav($_[1]);
  };
  foreach my $keysindia (keys %{$LSS1}) {
      my $texto = join("\n",@{$LSS1->{$keysindia}}) . "\n";
      open LSS1, ">>$keysindia.lss1";
      print LSS1 $texto;
  };
  mensaje ("código s3: $_[0]") if $ENV{USER} eq 'loli'; close LSS1;
  exit $_[0];
}#parar3
#------------------------------------------------------------------------------
sub help{
    pod2usage({-verbose => 0
           ,-exit => 1
	   ,-message => "   $progname $version
       es parte del conjunto de scripts de S I M U S O L
            más ayuda con   
	       man $progname
	    y luego salga con   q\n"   
	   });	   
}
#----------------------------------------------------------------------------
sub version{
    print "\n      $progname  $version\n\n";
    exit
}





